    PROGRAM g01fcfe

!      G01FCF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : g01fcf, nag_wp
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
!      .. Local Scalars ..
       REAL (KIND=nag_wp)              :: df, p, x
       INTEGER                         :: ifail
!      .. Executable Statements ..
       WRITE (nout,*) 'G01FCF Example Program Results'
       WRITE (nout,*)

!      Skip heading in data file
       READ (nin,*)

!      Display titles
       WRITE (nout,*) '     P       DF      X'
       WRITE (nout,*)

D_LP:  DO
          READ (nin,*,IOSTAT=ifail) p, df
          IF (ifail/=0) THEN
             EXIT D_LP
          END IF

!         Calculate deviates (inverse CDF)
          ifail = -1
          x = g01fcf(p,df,ifail)
          IF (ifail/=0) THEN
             IF (ifail/=4 .AND. ifail/=5) THEN
                EXIT D_LP
             END IF
          END IF

!         Display results
          WRITE (nout,99999) p, df, x
       END DO D_LP

99999  FORMAT (1X,3F8.3,A,I1)
    END PROGRAM g01fcfe
